/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FORMAC                                                   */
/* Tabela : FORMACOMU                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 22/07/2004 - CEZAR VINICIUS ROLIM       					      */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FORMACOMU'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FORMACOMU
GO

CREATE TRIGGER DTULTATU_FORMACOMU
ON FORMACOMU
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FORMACOMU', null, 'CDFORMACOMU=' + CDFORMACOMU + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FORMACOMU
      SET DTULTATUFORC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(FORMACOMU.CDFORMACOMU,0) = ISNULL(INSERTED.CDFORMACOMU,0)) AND
            (ISNULL(FORMACOMU.NMFORMACOMU,0) = ISNULL(INSERTED.NMFORMACOMU,0)) ;
   END;
END;
GO